src/Entity/Answer.php
<?php

namespace App\Entity;

use App\Repository\AnswerRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=AnswerRepository::class)
 */
class Answer
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $content;

    /**
     * @ORM\Column(type="integer")
     */
    private $vote_count;

    /**
     * @ORM\ManyToOne(targetEntity=Poll::class, inversedBy="answers")
     * @ORM\JoinColumn(nullable=false)
     */
    private $poll;

    public function __construct()
    {
        return $this->setVoteCount(0);
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getContent(): ?string
    {
        return $this->content;
    }

    public function setContent(string $content): self
    {
        $this->content = $content;

        return $this;
    }

    public function getVoteCount(): ?int
    {
        return $this->vote_count;
    }

    public function setVoteCount(int $vote_count): self
    {
        $this->vote_count = $vote_count;

        return $this;
    }

    public function getPoll(): ?Poll
    {
        return $this->poll;
    }

    public function setPoll(?Poll $poll): self
    {
        $this->poll = $poll;

        return $this;
    }
}

src/Entity/Poll.php
<?php

namespace App\Entity;

use App\Repository\PollRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=PollRepository::class)
 */
class Poll
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $title;

    /**
     * @ORM\Column(type="boolean")
     */
    private $type;

    /**
     * @ORM\Column(type="boolean")
     */
    private $draft;

    /**
     * @ORM\OneToMany(targetEntity=Answer::class, mappedBy="poll", orphanRemoval=true, cascade={"persist"})
     */
    private $answers;

    /**
     * @ORM\Column(type="datetime")
     */
    private $date;

    public function __construct()
    {
        $this->answers = new ArrayCollection();
        $this->date = new \DateTime();
    }

    public function __toString()
    {
        return (string)$this->answers;
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getType(): ?bool
    {
        return $this->type;
    }

    public function setType(bool $type): self
    {
        $this->type = $type;

        return $this;
    }

    public function getDraft(): ?bool
    {
        return $this->draft;
    }

    public function setDraft(bool $draft): self
    {
        $this->draft = $draft;

        return $this;
    }

    /**
     * @return Collection|Answer[]
     */
    public function getAnswers(): Collection
    {
        return $this->answers;
    }

    public function addAnswer(Answer $answer): self
    {
        if (!$this->answers->contains($answer)) {
            $this->answers[] = $answer;
            $answer->setPoll($this);
        }

        return $this;
    }

    public function removeAnswer(Answer $answer): self
    {
        if ($this->answers->contains($answer)) {
            $this->answers->removeElement($answer);
            // set the owning side to null (unless already changed)
            if ($answer->getPoll() === $this) {
                $answer->setPoll(null);
            }
        }

        return $this;
    }

    public function getDate(): ?\DateTimeInterface
    {
        return $this->date;
    }

    public function setDate(\DateTimeInterface $date): self
    {
        $this->date = $date;

        return $this;
    }
}

src/Form/PollType.php
<?php

namespace App\Form;

use App\Entity\Poll;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class PollType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('title', TextType::class, [
                'label' => false,
                'attr' => [
                    'placeholder' => 'Type your question here'
                ]
            ])
            ->add('answers', CollectionType::class, [
                'label' => false,
                'entry_type' => AnswerType::class,
                'entry_options' => ['label' => false],
                'allow_add' => true,
                'by_reference' => false,

            ])
            ->add('type', CheckboxType::class, [
                'required' => false,
            ])
            ->add('draft', CheckboxType::class, [
                'required' => false,
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Poll::class,
        ]);
    }
}

src/Controller/PollController.php
<?php

namespace App\Controller;

use App\Entity\Answer;
use App\Entity\Poll;
use App\Form\PollType;
use App\Form\VoteType;
use App\Repository\PollRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/")
 */
class PollController extends AbstractController
{
    /**
     * @Route("/", name="poll_index", methods={"GET"})
     */
    public function index(PollRepository $pollRepository): Response
    {
        return $this->render('poll/index.html.twig', [
            'polls' => $pollRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="poll_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $poll = new Poll();
        $form = $this->createForm(PollType::class, $poll);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($poll);
            $entityManager->flush();

            return $this->redirectToRoute('poll_index');
        }

        return $this->render('poll/new.html.twig', [
            'poll' => $poll,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}/result", name="poll_result")
     */
    public function result(Poll $poll, $id, EntityManagerInterface $entityManager): Response {
        $arrayofanswers = $entityManager->getRepository(Answer::class)->findBy([
            'poll' => $id,
        ]);
        dump($arrayofanswers);
        return $this->render('poll/results.html.twig', [
            'poll' => $poll,
            'answers' => $arrayofanswers,
        ]);
    }

    /**
     * @Route("/{id}", name="poll_show", methods={"GET","POST"})
     */
    public function show(Poll $poll, EntityManagerInterface $entityManager, Request $request, $id): Response
    {
        $pollVote = $entityManager->getRepository(Poll::class)->find($id);
        $type = $poll->getType();

        $form = $this->createForm(VoteType::class, null, [
            'content' => $pollVote->getAnswers(),
            'type' => $poll->getType(),
        ]);
        $form->handleRequest($request);

        if($form->isSubmitted() && $form->isValid()) {
            // si reponse multiples
            if($type === true) {
                $selectaws = $form['content']->getData();

                foreach ($selectaws as $selectedawr) {

                    //add +1 aux vote pour chaque question selectionnées
                    $selectedawr->setVoteCount($selectedawr->getVoteCount()+1);
                    //persist
                    $entityManager = $this->getDoctrine()->getManager();
                    $entityManager->persist($selectedawr);
                }
            }
            //si reponse unique
            else {
                $selectedaws = $form['content']->getData();
                //+1 aux vote de la question choisie
                $selectedaws->setVoteCount($selectedaws->getVoteCount()+1);
                $entityManager = $this->getDoctrine()->getManager();
                $entityManager->persist($selectedaws);
            }

            $entityManager->flush();
            return $this->redirectToRoute('poll_result', [
                'id' => $poll->getId(),
                ]);
        }

        return $this->render('poll/show.html.twig', [
            'voteform' => $form->createView(),
            'type' => $type,
            'content' => $pollVote->getAnswers(),
            'poll' => $poll
        ]);
    }

    /**
     * @Route("/{id}/edit", name="poll_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Poll $poll): Response
    {
        $form = $this->createForm(PollType::class, $poll);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('poll_index');
        }

        return $this->render('poll/edit.html.twig', [
            'poll' => $poll,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="poll_delete", methods={"DELETE"})
     */
    public function delete(Request $request, Poll $poll): Response
    {
        if ($this->isCsrfTokenValid('delete'.$poll->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($poll);
            $entityManager->flush();
        }

        return $this->redirectToRoute('poll_index');
    }
}

templates/poll/_delete_form.html.twig
<form method="post" action="{{ path('poll_delete', {'id': poll.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ poll.id) }}">
    <button class="btn">Delete</button>
</form>

templates/poll/_form.html.twig
{{ form_start(form) }}
    {{ form_row(form.title) }}
    {{ form_row(form.answers) }}
    <button type="button" class="add_answer_link btn"><img src="{{ asset('build/logo/plus.png') }}" alt=""></button>
    {{ form_rest(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/poll/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Poll index{% endblock %}

{% block body %}
    <h1>Vos Sondages</h1>
    <section class="poll_section">

        {% for poll in polls %}
            <div class="card_polls">
                <h2>{{ poll.title }}</h2>
                <p>Nombres de réponses : {{ poll.answers.count }}</p>
                <p>{{ poll.date ? poll.date|date('d/m/Y') : '' }}</p>
                <div class="link-divs">
                    <a href="{{ path('poll_show', {'id': poll.id}) }}">Voter</a>
                </div>
            </div>
        {% else %}
                <p colspan="6">no records found</p>
        {% endfor %}

    </section>
    <a href="{{ path('poll_new') }}" class="link_new"><img src="{{ asset('build/logo/plus.png') }}" alt=""></a>
{% endblock %}

templates/poll/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Poll{% endblock %}

{% block body %}
    <h1>Create new Poll</h1>

    <section class="form-section">
        {{ include('poll/_form.html.twig') }}
    </section>

    <a href="{{ path('poll_index') }}">back to list</a>
{% endblock %}

templates/poll/results.html.twig
{% extends 'base.html.twig' %}

{% block title %}Results{% endblock %}

{% block body %}
    <h1>{{ poll.title }}</h1>
    <h3 id="vote-toto"></h3>

    <div id="MyDonut"></div>
    <div id="myAnswers">
        {% for answer in poll.answers %}
            <div value="{{ answer.content }}"></div>
        {% endfor %}
    </div>
    <div id="vote-div">
        {% for answer in answers %}
            <div value="{{ answer.voteCount }}"></div>
        {% endfor %}
    </div>
{% endblock %}
{% block javascripts %}
    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
    <script type="text/javascript">
        let myanswersdiv = document.getElementById("myAnswers");
        let myvotediv = document.getElementById('vote-div');
        let votetototxt = document.getElementById('vote-toto');
        let votetotaux = 0;
        google.charts.load('current', {'packages':['corechart']});
        google.charts.setOnLoadCallback(drawChart);

        function drawChart() {
            let myprincipalarray = [];
            myprincipalarray.push(['Reponses', 'Votes']);
            for (let i = 0; i < myanswersdiv.children.length; i++) {
                let myarrayofanswer = [];
                let myanswers = myanswersdiv.children[i].getAttribute('value');
                let myvotes = myvotediv.children[i].getAttribute('value');
                myarrayofanswer.push(myanswers);
                votetotaux += parseInt(myvotes);
                myarrayofanswer.push(parseInt(myvotes));
                myprincipalarray.push(myarrayofanswer);
            }
            votetototxt.innerText = `${votetotaux} votes au total.`

            let data = google.visualization.arrayToDataTable(myprincipalarray);

            let options = {
                height: 400,
                pieHole: 0.4,
                backgroundColor: '#323232',
                colors: ['#e0440e', '#e6693e', '#ec8f6e', '#f3b49f', '#f6c7b6'],
                is3D: true,
                legend: {
                    position: 'bottom',
                    textStyle: {
                        color: 'white',
                    }
                }

            };

            let chart = new google.visualization.PieChart(document.getElementById('MyDonut'));

            chart.draw(data, options);
        }
    </script>
{% endblock %}

templates/poll/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Poll{% endblock %}

{% block body %}
    <h1>{{ poll.title }}</h1>

    <section class="vote-section">
        {{ form_start(voteform) }}
            {% for content in voteform.content %}
                <div>{{ form_widget(content) }}{{ form_label(content) }}</div>
            {% endfor %}
    {{ form_rest(voteform) }}
    <button class="btn" type="submit">vote</button>
        {{ form_end(voteform) }}
    </section>
{% endblock %}